## intel-ipsec-mb 1.0

=== Makefile ===
#
# Copyright (c) 2020-2021, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

.PHONY: all clean style install uninstall help TAGS

all:
	$(MAKE) -C lib
	$(MAKE) -C test
	$(MAKE) -C perf

clean:
	$(MAKE) -C lib clean
	$(MAKE) -C test clean
	$(MAKE) -C perf clean

style:
	$(MAKE) -C lib style
	$(MAKE) -C test style
	$(MAKE) -C perf style

install:
	$(MAKE) -C lib install

uninstall:
	$(MAKE) -C lib uninstall

help:
	$(MAKE) -C lib help

README: README.md
	pandoc -f markdown -t plain $< -o $@

.PHONY: TAGS
TAGS:
	find ./ -name "*.[ch]" -print | etags -
	find ./ -name '*.asm'  | etags -a -
	find ./ -name '*.inc'  | etags -a -

# Check spelling in the code with codespell.
# See https://github.com/codespell-project/codespell for more details.
# Codespell options explained:
# -d        -- disable colours (emacs colours it anyway)
# -L        -- List of words to be ignored
# -S <skip> -- skip file types
# -I FILE   -- File containing words to be ignored
#
CODESPELL ?= codespell
CS_IGNORE_WORDS ?= iinclude,struc,fo,ue,od,ba

.PHONY: spellcheck
spellcheck:
	$(CODESPELL) -d -L $(CS_IGNORE_WORDS) \
	-S "*.obj,*.o,*.a,*.so,*.lib,*~,*.so,*.so.*,*.d,ipsec_perf" \
	-S "ipsec_MB_testapp,ipsec_xvalid_test" \
	./lib ./perf ./test README README.md SECURITY.md CONTRIBUTING \
	Makefile win_x64.mak ReleaseNotes.txt LICENSE $(CS_EXTRA_OPTS)

=== lib/Makefile ===
#
# Copyright (c) 2012-2021, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

LIB = libIPSec_MB
SHARED ?= y
IMB_HDR = intel-ipsec-mb.h

# Detect library version
IMB_VERSION = $(shell grep -e "IMB_VERSION_STR" $(IMB_HDR) | cut -d'"' -f2)
ifeq ($(IMB_VERSION),)
$(error "Failed to detect library version!")
endif

VERSION = $(shell echo $(IMB_VERSION) | cut -d. -f1-3)
SO_VERSION = $(shell echo $(VERSION) | cut -d. -f1)

PREFIX ?= /usr
LIB_INSTALL_DIR ?= $(PREFIX)/lib
HDR_DIR ?= $(PREFIX)/include
MAN_DIR ?= $(PREFIX)/man/man7
MAN1 = libipsec-mb.7
MAN2 = libipsec-mb-dev.7
NOLDCONFIG ?= n

USE_YASM ?= n
YASM ?= yasm
NASM ?= nasm

# Detect NASM version (minimum version required: 2.14)
NASM_VERSION = $(shell $(NASM) -v | cut -d " " -f 3)

NASM_MAJOR_REQ = 2
NASM_MINOR_REQ = 14

ifeq ($(NASM_VERSION),)
$(error "NASM is not installed! Minimum required version: $(NASM_MAJOR_REQ).$(NASM_MINOR_REQ)")
else
NASM_MAJOR_VER = $(shell echo $(NASM_VERSION) | cut -d "." -f 1)
NASM_MINOR_VER = $(shell echo $(NASM_VERSION) | cut -d "." -f 2 | cut -c 1-2)
NASM_GE_MAJOR = $(shell [ $(NASM_MAJOR_VER) -ge $(NASM_MAJOR_REQ) ] && echo true)
NASM_GE_MINOR = $(shell [ $(NASM_MINOR_VER) -ge $(NASM_MINOR_REQ) ] && echo true)
ifneq ($(NASM_GE_MAJOR),true)
$(warning "NASM version found: $(NASM_VERSION)")
$(error "Minimum required: $(NASM_MAJOR_REQ).$(NASM_MINOR_REQ)")
endif
ifneq ($(NASM_GE_MINOR),true)
$(warning "NASM version found: $(NASM_VERSION)")
$(error "Minimum required: $(NASM_MAJOR_REQ).$(NASM_MINOR_REQ)")
endif
endif

OBJ_DIR ?= obj
LIB_DIR ?= .

INCLUDE_DIRS := include . no-aesni
INCLUDES := $(foreach i,$(INCLUDE_DIRS),-I $i)

CC ?= gcc

# if "-z ibt" is supported then assume "-z shstk, -z cet-report=error" are also supported
# "-fcf-protection" needs to be checked separately
CC_HAS_CET = $(and $(shell $(CC) --target-help 2> /dev/null | grep -m1 -e "-z ibt" | wc -l), \
	$(shell $(CC) --help=common 2> /dev/null | grep -m1 -e "-fcf-protection" | wc -l))
CET_LDFLAGS=-r -z ibt -z shstk

CFLAGS := -DLINUX -DNO_COMPAT_IMB_API_053 $(EXTRA_CFLAGS) $(INCLUDES) \
	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
	-Wcast-qual -Wundef -Wwrite-strings  \
	-Wformat -Wformat-security \
	-Wunreachable-code -Wmissing-noreturn -Wsign-compare -Wno-endif-labels \
	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition \
	-fno-strict-overflow -fno-delete-null-pointer-checks -fwrapv

ifeq ($(CC_HAS_CET),1)
CFLAGS += -fcf-protection=full
endif

ASM_INCLUDE_DIRS := .

YASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I $i)
YASM_FLAGS := -f x64 -f elf64 -X gnu -g dwarf2 -DLINUX -D__linux__ $(YASM_INCLUDES)

NASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I$i/)
NASM_FLAGS := -Werror -felf64 -Xgnu -gdwarf -DLINUX -D__linux__ $(NASM_INCLUDES)

DEBUG_OPT ?= -O0
ifeq ($(DEBUG),y)
CFLAGS += -g -DDEBUG
OPT = $(DEBUG_OPT)
LDFLAGS += -g
else
OPT = -O3
CFLAGS += -fstack-protector -D_FORTIFY_SOURCE=2
endif

ifneq ($(SAFE_DATA),n)
CFLAGS += -DSAFE_DATA
NASM_FLAGS += -DSAFE_DATA
YASM_FLAGS += -DSAFE_DATA
endif

ifneq ($(SAFE_PARAM),n)
CFLAGS += -DSAFE_PARAM
NASM_FLAGS += -DSAFE_PARAM
YASM_FLAGS += -DSAFE_PARAM
endif

ifneq ($(SAFE_LOOKUP),n)
CFLAGS += -DSAFE_LOOKUP
NASM_FLAGS += -DSAFE_LOOKUP
YASM_FLAGS += -DSAFE_LOOKUP
endif

# prevent SIMD optimizations for non-aesni modules
CFLAGS_NO_SIMD = $(CFLAGS) -O1
CFLAGS += $(OPT)

# Set generic architectural optimizations
OPT_X86 := -msse4.2
OPT_SSE := -msse4.2 -maes -mpclmul
OPT_AVX := -mavx -maes -mpclmul
OPT_AVX2 := -mavx2 -maes -mpclmul
OPT_AVX512 := -mavx2 -maes -mpclmul # -mavx512f is not available until gcc 4.9
OPT_NOAESNI := -msse4.2 -mno-aes -mno-pclmul

# Set architectural optimizations for GCC/CC
ifeq ($(CC),$(filter $(CC),gcc cc))
GCC_VERSION = $(shell $(CC) -dumpversion | cut -d. -f1)
GCC_GE_V5 = $(shell [ $(GCC_VERSION) -ge 5 ] && echo true)
ifeq ($(GCC_GE_V5),true)
OPT_SSE := -march=nehalem -maes -mpclmul
OPT_AVX := -march=sandybridge -maes -mpclmul
OPT_AVX2 := -march=haswell -maes -mpclmul
OPT_AVX512 := -march=broadwell -maes -mpclmul
OPT_NOAESNI := -march=nehalem -mno-pclmul
endif
endif

# Set architectural optimizations for clang
ifeq ($(CC),$(filter $(CC),clang))
CLANG_VERSION = $(shell $(CC) --version | head -n 1 | cut -d ' ' -f 3)
CLANG_GE_V381 = $(shell test "$(CLANG_VERSION)" \> "3.8.0" && echo true)
ifeq ($(CLANG_GE_V381),true)
OPT_SSE := -march=nehalem -maes -mpclmul
OPT_AVX := -march=sandybridge -maes -mpclmul
OPT_AVX2 := -march=haswell -maes -mpclmul
OPT_AVX512 := -march=broadwell -maes -mpclmul
endif
# remove CFLAGS that clang warns about
CFLAGS := $(subst -fno-delete-null-pointer-checks,,$(CFLAGS))
CFLAGS := $(subst -fno-strict-overflow,,$(CFLAGS))
endif

# so or static build
ifeq ($(SHARED),y)
CFLAGS += -fPIC
LIBNAME = $(LIB).so.$(VERSION)
LIBPERM = 0755
LDFLAGS += -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now
ifeq ($(CC_HAS_CET),1)
LDFLAGS += -fcf-protection=full -Wl,-z,ibt -Wl,-z,shstk -Wl,-z,cet-report=error
endif
else
CFLAGS += -fPIE
LIBNAME = $(LIB).a
LIBPERM = 0644
LDFLAGS += -g
ifeq ($(CC_HAS_CET),1)
LDFLAGS += -fcf-protection=full
endif
endif

# warning messages
SAFE_PARAM_MSG1="SAFE_PARAM option not set."
SAFE_PARAM_MSG2="Input parameters will not be checked."
SAFE_DATA_MSG1="SAFE_DATA option not set."
SAFE_DATA_MSG2="Stack and registers containing sensitive information, \
		such keys or IV will not be cleared \
		at the end of function calls."
SAFE_LOOKUP_MSG1="SAFE_LOOKUP option not set."
SAFE_LOOKUP_MSG2="Lookups which depend on sensitive information \
		are not guaranteed to be done in constant time."

#
# List of C modules (any origin)
#
c_lib_objs := \
	mb_mgr_avx.o \
	mb_mgr_avx2.o \
	mb_mgr_avx512.o \
	mb_mgr_sse.o \
	mb_mgr_sse_no_aesni.o \
	alloc.o \
	aes_xcbc_expand_key.o \
	md5_one_block.o \
	sha_sse.o \
	sha_avx.o \
	des_key.o \
	des_basic.o \
	version.o \
	cpu_feature.o \
	aesni_emu.o \
	kasumi_avx.o \
	kasumi_iv.o \
	kasumi_sse.o \
	zuc_sse_top.o \
	zuc_sse_no_aesni_top.o \
	zuc_avx_top.o \
	zuc_avx2_top.o \
	zuc_avx512_top.o \
	zuc_iv.o \
	snow3g_sse.o \
	snow3g_sse_no_aesni.o \
	snow3g_avx.o \
	snow3g_avx2.o \
	snow3g_tables.o \
	snow3g_iv.o \
	snow_v_sse.o \
	snow_v_sse_noaesni.o \
	mb_mgr_auto.o \
	error.o
#
# List of ASM modules (root directory/common)
#
asm_generic_lib_objs := \
	aes_keyexp_128.o \
	aes_keyexp_192.o \
	aes_keyexp_256.o \
	aes_cmac_subkey_gen.o \
	save_xmms.o \
	clear_regs_mem_fns.o \
	const.o \
	aes128_ecbenc_x3.o \
	zuc_common.o \
	wireless_common.o \
	constant_lookup.o \
	crc32_refl_const.o \
	crc32_const.o \
	poly1305.o \
	chacha20_poly1305.o

#
# List of ASM modules (no-aesni directory)
#
asm_noaesni_lib_objs := \
	aes128_cbc_dec_by4_sse_no_aesni.o \
	aes192_cbc_dec_by4_sse_no_aesni.o \
	aes256_cbc_dec_by4_sse_no_aesni.o \
	aes_cbc_enc_128_x4_no_aesni.o \
	aes_cbc_enc_192_x4_no_aesni.o \
	aes_cbc_enc_256_x4_no_aesni.o \
	aes128_cntr_by8_sse_no_aesni.o \
	aes192_cntr_by8_sse_no_aesni.o \
	aes256_cntr_by8_sse_no_aesni.o \
	aes_ecb_by4_sse_no_aesni.o \
	aes128_cntr_ccm_by8_sse_no_aesni.o \
	aes256_cntr_ccm_by8_sse_no_aesni.o \
	pon_sse_no_aesni.o \
	zuc_sse_no_aesni.o \
	aes_cfb_sse_no_aesni.o \
	aes128_cbc_mac_x4_no_aesni.o \
	aes256_cbc_mac_x4_no_aesni.o \
	aes_xcbc_mac_128_x4_no_aesni.o \
	mb_mgr_aes_flush_sse_no_aesni.o \
	mb_mgr_aes_submit_sse_no_aesni.o \
	mb_mgr_aes192_flush_sse_no_aesni.o \
	mb_mgr_aes192_submit_sse_no_aesni.o \
	mb_mgr_aes256_flush_sse_no_aesni.o \
	mb_mgr_aes256_submit_sse_no_aesni.o \
	mb_mgr_aes_cmac_submit_flush_sse_no_aesni.o \
	mb_mgr_aes256_cmac_submit_flush_sse_no_aesni.o \
	mb_mgr_aes_ccm_auth_submit_flush_sse_no_aesni.o \
	mb_mgr_aes256_ccm_auth_submit_flush_sse_no_aesni.o \
	mb_mgr_aes_xcbc_flush_sse_no_aesni.o \
	mb_mgr_aes_xcbc_submit_sse_no_aesni.o \
	mb_mgr_zuc_submit_flush_sse_no_aesni.o \
	ethernet_fcs_sse_no_aesni.o \
	crc16_x25_sse_no_aesni.o \
	aes_cbcs_1_9_enc_128_x4_no_aesni.o \
	aes128_cbcs_1_9_dec_by4_sse_no_aesni.o \
	mb_mgr_aes128_cbcs_1_9_submit_sse.o \
	mb_mgr_aes128_cbcs_1_9_flush_sse.o \
	mb_mgr_aes128_cbcs_1_9_submit_sse_no_aesni.o \
	mb_mgr_aes128_cbcs_1_9_flush_sse_no_aesni.o \
	crc32_refl_by8_sse_no_aesni.o \
	crc32_by8_sse_no_aesni.o \
	crc32_sctp_sse_no_aesni.o \
	crc32_lte_sse_no_aesni.o \
	crc32_fp_sse_no_aesni.o \
	crc32_iuup_sse_no_aesni.o \
	crc32_wimax_sse_no_aesni.o

#
# List of ASM modules (sse directory)
#
asm_sse_lib_objs := \
	aes128_cbc_dec_by4_sse.o \
	aes128_cbc_dec_by8_sse.o \
	aes192_cbc_dec_by4_sse.o \
	aes192_cbc_dec_by8_sse.o \
	aes256_cbc_dec_by4_sse.o \
	aes256_cbc_dec_by8_sse.o \
	aes_cbc_enc_128_x4.o \
	aes_cbc_enc_192_x4.o \
	aes_cbc_enc_256_x4.o \
	aes_cbc_enc_128_x8_sse.o \
	aes_cbc_enc_192_x8_sse.o \
	aes_cbc_enc_256_x8_sse.o \
	pon_sse.o \
	aes128_cntr_by8_sse.o \
	aes192_cntr_by8_sse.o \
	aes256_cntr_by8_sse.o \
	aes_ecb_by4_sse.o \
	aes128_cntr_ccm_by8_sse.o \
	aes256_cntr_ccm_by8_sse.o \
	aes_cfb_sse.o \
	aes128_cbc_mac_x4.o \
	aes256_cbc_mac_x4.o \
	aes128_cbc_mac_x8_sse.o \
	aes256_cbc_mac_x8_sse.o \
	aes_xcbc_mac_128_x4.o \
	md5_x4x2_sse.o \
	sha1_mult_sse.o \
	sha1_one_block_sse.o \
	sha224_one_block_sse.o \
	sha256_one_block_sse.o \
	sha384_one_block_sse.o \
	sha512_one_block_sse.o \
	sha512_x2_sse.o \
	sha_256_mult_sse.o \
	sha1_ni_x2_sse.o \
	sha256_ni_x2_sse.o \
	zuc_sse.o \
	zuc_sse_gfni.o \
	mb_mgr_aes_flush_sse.o \
	mb_mgr_aes_submit_sse.o \
	mb_mgr_aes192_flush_sse.o \
	mb_mgr_aes192_submit_sse.o \
	mb_mgr_aes256_flush_sse.o \
	mb_mgr_aes256_submit_sse.o \
	mb_mgr_aes_flush_sse_x8.o \
	mb_mgr_aes_submit_sse_x8.o \
	mb_mgr_aes192_flush_sse_x8.o \
	mb_mgr_aes192_submit_sse_x8.o \
	mb_mgr_aes256_flush_sse_x8.o \
	mb_mgr_aes256_submit_sse_x8.o \
	mb_mgr_aes_cmac_submit_flush_sse.o \
	mb_mgr_aes256_cmac_submit_flush_sse.o \
	mb_mgr_aes_cmac_submit_flush_sse_x8.o \
	mb_mgr_aes256_cmac_submit_flush_sse_x8.o \
	mb_mgr_aes_ccm_auth_submit_flush_sse.o \
	mb_mgr_aes_ccm_auth_submit_flush_sse_x8.o \
	mb_mgr_aes256_ccm_auth_submit_flush_sse.o \
	mb_mgr_aes256_ccm_auth_submit_flush_sse_x8.o \
	mb_mgr_aes_xcbc_flush_sse.o \
	mb_mgr_aes_xcbc_submit_sse.o \
	mb_mgr_hmac_md5_flush_sse.o \
	mb_mgr_hmac_md5_submit_sse.o \
	mb_mgr_hmac_flush_sse.o \
	mb_mgr_hmac_submit_sse.o \
	mb_mgr_hmac_sha_224_flush_sse.o \
	mb_mgr_hmac_sha_224_submit_sse.o \
	mb_mgr_hmac_sha_256_flush_sse.o \
	mb_mgr_hmac_sha_256_submit_sse.o \
	mb_mgr_hmac_sha_384_flush_sse.o \
	mb_mgr_hmac_sha_384_submit_sse.o \
	mb_mgr_hmac_sha_512_flush_sse.o \
	mb_mgr_hmac_sha_512_submit_sse.o \
	mb_mgr_hmac_flush_ni_sse.o \
	mb_mgr_hmac_submit_ni_sse.o \
	mb_mgr_hmac_sha_224_flush_ni_sse.o \

=== perf/Makefile ===
# Copyright (c) 2017-2021, Intel Corporation
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

EXE=ipsec_perf
INSTPATH ?= /usr/include/intel-ipsec-mb.h
LIB_DIR ?= ../lib
NASM ?= nasm

CFLAGS = -DLINUX -D_GNU_SOURCE -DNO_COMPAT_IMB_API_053 $(INCLUDES) \
	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
	-Wcast-qual -Wundef -Wwrite-strings  \
	-Wformat -Wformat-security \
	-Wunreachable-code -Wmissing-noreturn -Wsign-compare -Wno-endif-labels \
	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition \
	-pthread -fno-strict-overflow -fno-delete-null-pointer-checks -fwrapv

NASM_FLAGS := -Werror -felf64 -Xgnu -gdwarf -DLINUX -D__linux__

# if "-z ibt" is supported then assume "-z shstk, -z cet-report=error" are also supported
# "-fcf-protection" needs to be checked separately
CC_HAS_CET = $(and $(shell $(CC) --target-help 2> /dev/null | grep -m1 -e "-z ibt" | wc -l), \
	$(shell $(CC) --help=common 2> /dev/null | grep -m1 -e "-fcf-protection" | wc -l))
CET_LDFLAGS=-r -z ibt -z shstk

ifeq ($(CC_HAS_CET),1)
CFLAGS += -fcf-protection=full
endif

LDFLAGS = -fPIE -z noexecstack -z relro -z now -pthread
ifeq ($(CC_HAS_CET),1)
LDFLAGS += -fcf-protection=full -Wl,-z,ibt -Wl,-z,shstk -Wl,-z,cet-report=error
endif
LDLIBS = -lIPSec_MB

ifeq ("$(shell test -e $(INSTPATH) && echo -n yes)","yes")
# library installed
CFLAGS +=
else
# library not installed
CFLAGS +=  -I../lib/include -I../lib
LDFLAGS += -L$(LIB_DIR)
endif

DEBUG_OPT ?= -O0
ifeq ($(DEBUG),y)
CFLAGS += -g -DDEBUG $(DEBUG_OPT)
LDFLAGS += -g
else
CFLAGS += -O3 -fPIE -fstack-protector -D_FORTIFY_SOURCE=2
endif

SOURCES := ipsec_perf.c msr.c
ASM_SOURCES := misc.asm
OBJECTS := $(SOURCES:%.c=%.o) $(ASM_SOURCES:%.asm=%.o)

CHECKPATCH ?= checkpatch.pl
CPPCHECK ?= cppcheck

.PHONY: all clean style cppcheck

# rule for compiling assembly code with producing dependencies
%.o:%.asm
	$(NASM) -MD $(@:.o=.d) -MT $@ -o $@ $(NASM_FLAGS) $<
ifeq ($(CC_HAS_CET),1)
	$(LD) $(CET_LDFLAGS) -o $@.tmp $@
	mv $@.tmp $@
endif

all: $(EXE)

$(EXE): $(OBJECTS)
	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@

ipsec_perf.o: $(SOURCES)

.PHONY: clean
clean:
	-rm -f $(OBJECTS)
	-rm -f $(EXE)

SOURCES_STYLE := $(foreach infile,$(SOURCES),-f $(infile))
CHECKPATCH?=checkpatch.pl
.PHONY: style
style:
	$(CHECKPATCH) --no-tree --no-signoff --emacs --no-color \
--ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,\
UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,\
COMPLEX_MACRO,SPACING,STORAGE_CLASS,USE_FUNC,NEW_TYPEDEFS $(SOURCES_STYLE)

=== test/Makefile ===
#
# Copyright (c) 2012-2021, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

TEST_APP := ipsec_MB_testapp
XVALID_APP := ipsec_xvalid_test
INSTPATH ?= /usr/include/intel-ipsec-mb.h
LIB_DIR ?= ../lib

USE_YASM ?= n
YASM ?= yasm
NASM ?= nasm

CFLAGS = -MMD -DLINUX -D_GNU_SOURCE -DNO_COMPAT_IMB_API_053 \
	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
	-Wcast-qual -Wundef -Wwrite-strings  \
	-Wformat -Wformat-security \
	-Wunreachable-code -Wmissing-noreturn -Wsign-compare -Wno-endif-labels \
	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition \
	-fno-strict-overflow -fno-delete-null-pointer-checks -fwrapv

# if "-z ibt" is supported then assume "-z shstk, -z cet-report=error" are also supported
# "-fcf-protection" needs to be checked separately
CC_HAS_CET = $(and $(shell $(CC) --target-help 2> /dev/null | grep -m1 -e "-z ibt" | wc -l), \
	$(shell $(CC) --help=common 2> /dev/null | grep -m1 -e "-fcf-protection" | wc -l))
CET_LDFLAGS=-r -z ibt -z shstk

ifeq ($(CC_HAS_CET),1)
CFLAGS += -fcf-protection=full
endif

YASM_FLAGS := -f x64 -f elf64 -X gnu -g dwarf2 -DLINUX -D__linux__
NASM_FLAGS := -Werror -felf64 -Xgnu -gdwarf -DLINUX -D__linux__

LDFLAGS = -fPIE -z noexecstack -z relro -z now
ifeq ($(CC_HAS_CET),1)
LDFLAGS += -fcf-protection=full -Wl,-z,ibt -Wl,-z,shstk -Wl,-z,cet-report=error
endif
LDLIBS = -lIPSec_MB

ifeq ("$(shell test -r $(INSTPATH) && echo -n yes)","yes")
# library installed
CFLAGS +=
else
# library not installed
CFLAGS +=  -I../lib/include -I../lib
LDFLAGS += -L$(LIB_DIR)
endif

DEBUG_OPT ?= -O0
ifeq ($(DEBUG),y)
CFLAGS += $(DEBUG_OPT) -DDEBUG -g
LDFLAGS += -g
else
CFLAGS += -O3
endif

# ipsec_MB_testapp modules
SOURCES := main.c gcm_test.c ctr_test.c customop_test.c des_test.c ccm_test.c \
	cmac_test.c utils.c hmac_sha1_test.c hmac_sha256_sha512_test.c \
	hmac_md5_test.c aes_test.c sha_test.c chained_test.c api_test.c pon_test.c \
	ecb_test.c zuc_test.c kasumi_test.c snow3g_test.c direct_api_test.c clear_mem_test.c \
	hec_test.c xcbc_test.c aes_cbcs_test.c crc_test.c chacha_test.c poly1305_test.c \
	chacha20_poly1305_test.c null_test.c snow_v_test.c
OBJECTS := $(SOURCES:%.c=%.o)

# ipsec_xvalid_test modules
XVALID_ASM := misc.asm
XVALID_SOURCES := ipsec_xvalid.c utils.c
XVALID_OBJECTS := $(XVALID_SOURCES:%.c=%.o) $(XVALID_ASM:%.asm=%.o)

# list of present dependency files
DEP_FILES = $(wildcard ./*.d)

# rule for compiling assembly code with producing dependencies
%.o:%.asm
ifeq ($(USE_YASM),y)
	$(YASM) $(YASM_FLAGS) $< -o $@
else
	$(NASM) -MD $(@:.o=.d) -MT $@ -o $@ $(NASM_FLAGS) $<
endif
ifeq ($(CC_HAS_CET),1)
	$(LD) $(CET_LDFLAGS) -o $@.tmp $@
	mv $@.tmp $@
endif

# targets come here
all: $(TEST_APP) $(XVALID_APP)

$(TEST_APP): $(OBJECTS)
	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@

$(XVALID_APP): $(XVALID_OBJECTS)
	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@

.PHONY: clean
clean:
	-rm -f $(OBJECTS) $(TEST_APP) $(DEP_FILES) $(XVALID_OBJECTS) $(XVALID_APP) $(ASM_OBJECTS)

# style check section
CHECKPATCH?=checkpatch.pl
CHECKPATCH_FLAGS = --no-tree --no-signoff --emacs --no-color --ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,AVOID_EXTERNS,COMPLEX_MACRO,USE_FUNC,CONSTANT_COMPARISON,MISSING_SPACE,NEW_TYPEDEFS

%.c_style_check : %.c
	$(CHECKPATCH) $(CHECKPATCH_FLAGS) -f $<

%.h_style_check : %.h
	$(CHECKPATCH) $(CHECKPATCH_FLAGS) -f $<

%.asm_style_check : %.asm
	$(CHECKPATCH) $(CHECKPATCH_FLAGS) -f $<

%.inc_style_check : %.inc
	$(CHECKPATCH) $(CHECKPATCH_FLAGS) -f $<

SOURCES_ALL := $(wildcard *.[ch]) $(wildcard *.asm) $(wildcard *.inc)
SOURCES_STYLE := $(foreach infile,$(SOURCES_ALL),$(infile)_style_check)

.PHONY: style
style: $(SOURCES_STYLE)

# if target not clean or rinse then make dependencies
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),style)
-include $(wildcard *.d)
endif
endif

=== debian/changelog ===
intel-ipsec-mb (1.0-1) unstable; urgency=medium

  * Sync to latest 1.0 release
  * Rename libipsec-mb0 to libipsec-mb1
  * Remove debian/watch as the upstream project is not serving tarballs now
  * Add note about elf debug optimization being disabled in rules
  * Add back the Uploaders field in the control file

 -- Colin Ian King <colin.king@canonical.com>  Fri, 7 May 2021 09:11:47 +0100

=== debian/control ===
Source: intel-ipsec-mb
Rules-Requires-Root: no
Section: utils
Priority: optional
Uploaders: Kamal Mostafa <kamal@whence.com>
Maintainer: Colin Ian King <colin.king@canonical.com>
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13),
               nasm
Standards-Version: 4.1.2
Homepage: https://github.com/intel/intel-ipsec-mb

Package: libipsec-mb1
Section: libs
Architecture: amd64
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Intel(R) Multi-Buffer Crypto for IPSec library
 Libipsec-mb is highly-optimized software implementations of
 the core cryptographic processing for IPsec, which provides
 industry-leading performance on a range of Intel(R) Processors.

Package: libipsec-mb-dev
Section: libdevel
Architecture: linux-amd64
Priority: optional
Depends: ${misc:Depends}, libipsec-mb1 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Development files for Intel(R) Multi-Buffer Crypto for IPSec library
 Libipsec-mb is highly-optimized software implementations of
 the core cryptographic processing for IPsec, which provides
 industry-leading performance on a range of Intel(R) Processors.

## intel-ipsec-mb 1.2

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2020-2021, Intel Corporation
+# Copyright (c) 2020-2022, Intel Corporation
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -51,6 +51,9 @@
 help:
 	$(MAKE) -C lib help
 
+doxy:
+	$(MAKE) -C lib doxy
+
 README: README.md
 	pandoc -f markdown -t plain $< -o $@

=== lib/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2012-2021, Intel Corporation
+# Copyright (c) 2012-2022, Intel Corporation
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -80,14 +80,17 @@
 INCLUDES := $(foreach i,$(INCLUDE_DIRS),-I $i)
 
 CC ?= gcc
+# MINGW should be non-zero value if detected
+MINGW ?= $(shell $(CC) -dM -E - < /dev/null | grep -i mingw | wc -l | sed 's/^ *//')
 
 # if "-z ibt" is supported then assume "-z shstk, -z cet-report=error" are also supported
 # "-fcf-protection" needs to be checked separately
+ifeq ($(MINGW),0)
 CC_HAS_CET = $(and $(shell $(CC) --target-help 2> /dev/null | grep -m1 -e "-z ibt" | wc -l), \
 	$(shell $(CC) --help=common 2> /dev/null | grep -m1 -e "-fcf-protection" | wc -l))
 CET_LDFLAGS=-r -z ibt -z shstk
-
-CFLAGS := -DLINUX -DNO_COMPAT_IMB_API_053 $(EXTRA_CFLAGS) $(INCLUDES) \
+endif
+CFLAGS := -DNO_COMPAT_IMB_API_053 $(EXTRA_CFLAGS) $(INCLUDES) \
 	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
 	-Wcast-qual -Wundef -Wwrite-strings  \
 	-Wformat -Wformat-security \
@@ -95,6 +98,10 @@
 	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition \
 	-fno-strict-overflow -fno-delete-null-pointer-checks -fwrapv
 
+ifeq ($(MINGW),0)
+CFLAGS += -DLINUX
+endif
+
 ifeq ($(CC_HAS_CET),1)
 CFLAGS += -fcf-protection=full
 endif
@@ -102,10 +109,14 @@
 ASM_INCLUDE_DIRS := .
 
 YASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I $i)
+NASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I$i/)
+ifneq ($(MINGW),0)
+YASM_FLAGS := -f x64 -f win64 -X gnu -g dwarf2 -DWIN_ABI $(YASM_INCLUDES)
+NASM_FLAGS := -Werror -fwin64 -Xvc -gcv8 -DWIN_ABI $(NASM_INCLUDES)
+else
 YASM_FLAGS := -f x64 -f elf64 -X gnu -g dwarf2 -DLINUX -D__linux__ $(YASM_INCLUDES)
-
-NASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I$i/)
 NASM_FLAGS := -Werror -felf64 -Xgnu -gdwarf -DLINUX -D__linux__ $(NASM_INCLUDES)
+endif
 
 DEBUG_OPT ?= -O0
 ifeq ($(DEBUG),y)
@@ -113,8 +124,19 @@
 OPT = $(DEBUG_OPT)
 LDFLAGS += -g
 else
+ifeq ($(MINGW),0)
 OPT = -O3
 CFLAGS += -fstack-protector -D_FORTIFY_SOURCE=2
+else
+OPT = -O2
+LDFLAGS += -s
+endif
+endif
+
+ifeq ($(SAFE_OPTIONS), n)
+SAFE_DATA = n
+SAFE_PARAM = n
+SAFE_LOOKUP = n
 endif
 
 ifneq ($(SAFE_DATA),n)
@@ -133,6 +155,12 @@
 CFLAGS += -DSAFE_LOOKUP
 NASM_FLAGS += -DSAFE_LOOKUP
 YASM_FLAGS += -DSAFE_LOOKUP
+endif
+
+ifeq ($(AESNI_EMU),y)
+CFLAGS += -DAESNI_EMU
+NASM_FLAGS += -DAESNI_EMU
+YASM_FLAGS += -DAESNI_EMU
 endif
 
 # prevent SIMD optimizations for non-aesni modules
@@ -178,9 +206,13 @@
 # so or static build
 ifeq ($(SHARED),y)
 CFLAGS += -fPIC
+ifneq ($(MINGW),0)
+LIBNAME = $(LIB).dll
+else
 LIBNAME = $(LIB).so.$(VERSION)
+LDFLAGS += -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now
+endif
 LIBPERM = 0755
-LDFLAGS += -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now
 ifeq ($(CC_HAS_CET),1)
 LDFLAGS += -fcf-protection=full -Wl,-z,ibt -Wl,-z,shstk -Wl,-z,cet-report=error
 endif
@@ -204,6 +236,8 @@
 SAFE_LOOKUP_MSG1="SAFE_LOOKUP option not set."
 SAFE_LOOKUP_MSG2="Lookups which depend on sensitive information \
 		are not guaranteed to be done in constant time."
+SAFE_OPTIONS_MSG1="SAFE_OPTIONS not specified."
+SAFE_OPTIONS_MSG2="All safe options enabled by default."
 
 #
 # List of C modules (any origin)
@@ -213,7 +247,6 @@
 	mb_mgr_avx2.o \
 	mb_mgr_avx512.o \
 	mb_mgr_sse.o \
-	mb_mgr_sse_no_aesni.o \
 	alloc.o \
 	aes_xcbc_expand_key.o \
 	md5_one_block.o \
@@ -223,26 +256,31 @@
 	des_basic.o \
 	version.o \
 	cpu_feature.o \
-	aesni_emu.o \
 	kasumi_avx.o \
 	kasumi_iv.o \
 	kasumi_sse.o \
-	zuc_sse_top.o \
-	zuc_sse_no_aesni_top.o \
-	zuc_avx_top.o \
-	zuc_avx2_top.o \
-	zuc_avx512_top.o \
+	zuc_top_sse.o \
+	zuc_top_avx.o \
+	zuc_top_avx2.o \
+	zuc_top_avx512.o \
 	zuc_iv.o \
 	snow3g_sse.o \
-	snow3g_sse_no_aesni.o \
 	snow3g_avx.o \
 	snow3g_avx2.o \
+	snow3g_avx512.o \
 	snow3g_tables.o \
 	snow3g_iv.o \
-	snow_v_sse.o \
-	snow_v_sse_noaesni.o \
 	mb_mgr_auto.o \
 	error.o
+
+ifeq ($(AESNI_EMU), y)
+c_lib_objs := $(c_lib_objs) \
+	mb_mgr_sse_no_aesni.o \
+	aesni_emu.o \
+	zuc_top_sse_no_aesni.o \
+	snow3g_sse_no_aesni.o
+endif
+
 #
 # List of ASM modules (root directory/common)
 #
@@ -257,7 +295,7 @@
 	aes128_ecbenc_x3.o \
 	zuc_common.o \
 	wireless_common.o \
-	constant_lookup.o \
+	constant_lookup_fns.o \
 	crc32_refl_const.o \
 	crc32_const.o \
 	poly1305.o \
@@ -270,9 +308,9 @@
 	aes128_cbc_dec_by4_sse_no_aesni.o \
 	aes192_cbc_dec_by4_sse_no_aesni.o \
 	aes256_cbc_dec_by4_sse_no_aesni.o \
-	aes_cbc_enc_128_x4_no_aesni.o \
-	aes_cbc_enc_192_x4_no_aesni.o \
-	aes_cbc_enc_256_x4_no_aesni.o \
+	aes128_cbc_enc_x4_sse_no_aesni.o \
+	aes192_cbc_enc_x4_sse_no_aesni.o \
+	aes256_cbc_enc_x4_sse_no_aesni.o \
 	aes128_cntr_by8_sse_no_aesni.o \
 	aes192_cntr_by8_sse_no_aesni.o \
 	aes256_cntr_by8_sse_no_aesni.o \
@@ -282,28 +320,26 @@
 	pon_sse_no_aesni.o \
 	zuc_sse_no_aesni.o \
 	aes_cfb_sse_no_aesni.o \
-	aes128_cbc_mac_x4_no_aesni.o \
-	aes256_cbc_mac_x4_no_aesni.o \
-	aes_xcbc_mac_128_x4_no_aesni.o \
-	mb_mgr_aes_flush_sse_no_aesni.o \
-	mb_mgr_aes_submit_sse_no_aesni.o \
-	mb_mgr_aes192_flush_sse_no_aesni.o \
-	mb_mgr_aes192_submit_sse_no_aesni.o \
-	mb_mgr_aes256_flush_sse_no_aesni.o \
-	mb_mgr_aes256_submit_sse_no_aesni.o \
-	mb_mgr_aes_cmac_submit_flush_sse_no_aesni.o \
+	aes128_cbc_mac_x4_sse_no_aesni.o \
+	aes256_cbc_mac_x4_sse_no_aesni.o \
+	aes128_xcbc_mac_x4_sse_no_aesni.o \
+	mb_mgr_aes128_cbc_enc_flush_sse_no_aesni.o \
+	mb_mgr_aes128_cbc_enc_submit_sse_no_aesni.o \
+	mb_mgr_aes192_cbc_enc_flush_sse_no_aesni.o \
+	mb_mgr_aes192_cbc_enc_submit_sse_no_aesni.o \
+	mb_mgr_aes256_cbc_enc_flush_sse_no_aesni.o \
+	mb_mgr_aes256_cbc_enc_submit_sse_no_aesni.o \
+	mb_mgr_aes128_cmac_submit_flush_sse_no_aesni.o \
 	mb_mgr_aes256_cmac_submit_flush_sse_no_aesni.o \
-	mb_mgr_aes_ccm_auth_submit_flush_sse_no_aesni.o \
+	mb_mgr_aes128_ccm_auth_submit_flush_sse_no_aesni.o \
 	mb_mgr_aes256_ccm_auth_submit_flush_sse_no_aesni.o \
-	mb_mgr_aes_xcbc_flush_sse_no_aesni.o \
-	mb_mgr_aes_xcbc_submit_sse_no_aesni.o \
+	mb_mgr_aes128_xcbc_flush_sse_no_aesni.o \
+	mb_mgr_aes128_xcbc_submit_sse_no_aesni.o \
 	mb_mgr_zuc_submit_flush_sse_no_aesni.o \
 	ethernet_fcs_sse_no_aesni.o \
 	crc16_x25_sse_no_aesni.o \
-	aes_cbcs_1_9_enc_128_x4_no_aesni.o \
+	aes128_cbcs_1_9_enc_x4_sse_no_aesni.o \
 	aes128_cbcs_1_9_dec_by4_sse_no_aesni.o \
-	mb_mgr_aes128_cbcs_1_9_submit_sse.o \
-	mb_mgr_aes128_cbcs_1_9_flush_sse.o \
 	mb_mgr_aes128_cbcs_1_9_submit_sse_no_aesni.o \
 	mb_mgr_aes128_cbcs_1_9_flush_sse_no_aesni.o \
 	crc32_refl_by8_sse_no_aesni.o \
@@ -312,7 +348,9 @@
 	crc32_lte_sse_no_aesni.o \
 	crc32_fp_sse_no_aesni.o \
 	crc32_iuup_sse_no_aesni.o \
-	crc32_wimax_sse_no_aesni.o
+	crc32_wimax_sse_no_aesni.o \
+	snow_v_sse_no_aesni.o \
+	snow3g_uia2_sse_no_aesni.o
 
 #
 # List of ASM modules (sse directory)
@@ -324,72 +362,45 @@
 	aes192_cbc_dec_by8_sse.o \
 	aes256_cbc_dec_by4_sse.o \
 	aes256_cbc_dec_by8_sse.o \
-	aes_cbc_enc_128_x4.o \
-	aes_cbc_enc_192_x4.o \
-	aes_cbc_enc_256_x4.o \
-	aes_cbc_enc_128_x8_sse.o \
-	aes_cbc_enc_192_x8_sse.o \
-	aes_cbc_enc_256_x8_sse.o \
-	pon_sse.o \
+	aes128_cbc_enc_x4_sse.o \
+	aes192_cbc_enc_x4_sse.o \
+	aes256_cbc_enc_x4_sse.o \
+	aes128_cbc_enc_x8_sse.o \
+	aes192_cbc_enc_x8_sse.o \
+	aes256_cbc_enc_x8_sse.o \
+	pon_by8_sse.o \
 	aes128_cntr_by8_sse.o \
 	aes192_cntr_by8_sse.o \
 	aes256_cntr_by8_sse.o \
-	aes_ecb_by4_sse.o \
+	aes128_ecb_by4_sse.o \
+	aes192_ecb_by4_sse.o \
+	aes256_ecb_by4_sse.o \
 	aes128_cntr_ccm_by8_sse.o \
 	aes256_cntr_ccm_by8_sse.o \
 	aes_cfb_sse.o \
-	aes128_cbc_mac_x4.o \
-	aes256_cbc_mac_x4.o \
+	aes128_cbc_mac_x4_sse.o \
+	aes256_cbc_mac_x4_sse.o \
 	aes128_cbc_mac_x8_sse.o \
 	aes256_cbc_mac_x8_sse.o \
-	aes_xcbc_mac_128_x4.o \
+	aes128_xcbc_mac_x4_sse.o \
 	md5_x4x2_sse.o \
-	sha1_mult_sse.o \
+	sha1_x4_sse.o \
 	sha1_one_block_sse.o \
 	sha224_one_block_sse.o \
 	sha256_one_block_sse.o \
 	sha384_one_block_sse.o \
 	sha512_one_block_sse.o \
 	sha512_x2_sse.o \
-	sha_256_mult_sse.o \
+	sha256_mult_sse.o \
 	sha1_ni_x2_sse.o \
 	sha256_ni_x2_sse.o \
-	zuc_sse.o \
-	zuc_sse_gfni.o \
-	mb_mgr_aes_flush_sse.o \
-	mb_mgr_aes_submit_sse.o \
-	mb_mgr_aes192_flush_sse.o \
-	mb_mgr_aes192_submit_sse.o \
-	mb_mgr_aes256_flush_sse.o \
-	mb_mgr_aes256_submit_sse.o \
-	mb_mgr_aes_flush_sse_x8.o \
-	mb_mgr_aes_submit_sse_x8.o \
-	mb_mgr_aes192_flush_sse_x8.o \
-	mb_mgr_aes192_submit_sse_x8.o \
-	mb_mgr_aes256_flush_sse_x8.o \
-	mb_mgr_aes256_submit_sse_x8.o \
-	mb_mgr_aes_cmac_submit_flush_sse.o \
-	mb_mgr_aes256_cmac_submit_flush_sse.o \
-	mb_mgr_aes_cmac_submit_flush_sse_x8.o \
-	mb_mgr_aes256_cmac_submit_flush_sse_x8.o \
-	mb_mgr_aes_ccm_auth_submit_flush_sse.o \
-	mb_mgr_aes_ccm_auth_submit_flush_sse_x8.o \
-	mb_mgr_aes256_ccm_auth_submit_flush_sse.o \
-	mb_mgr_aes256_ccm_auth_submit_flush_sse_x8.o \
-	mb_mgr_aes_xcbc_flush_sse.o \
-	mb_mgr_aes_xcbc_submit_sse.o \
-	mb_mgr_hmac_md5_flush_sse.o \
-	mb_mgr_hmac_md5_submit_sse.o \
-	mb_mgr_hmac_flush_sse.o \
-	mb_mgr_hmac_submit_sse.o \
-	mb_mgr_hmac_sha_224_flush_sse.o \
-	mb_mgr_hmac_sha_224_submit_sse.o \
-	mb_mgr_hmac_sha_256_flush_sse.o \
-	mb_mgr_hmac_sha_256_submit_sse.o \
-	mb_mgr_hmac_sha_384_flush_sse.o \
-	mb_mgr_hmac_sha_384_submit_sse.o \
-	mb_mgr_hmac_sha_512_flush_sse.o \
-	mb_mgr_hmac_sha_512_submit_sse.o \
-	mb_mgr_hmac_flush_ni_sse.o \
-	mb_mgr_hmac_submit_ni_sse.o \
-	mb_mgr_hmac_sha_224_flush_ni_sse.o \
+	zuc_x4_sse.o \
+	zuc_gfni_sse.o \
+	mb_mgr_aes128_cbc_enc_flush_x4_sse.o \
+	mb_mgr_aes128_cbc_enc_submit_x4_sse.o \
+	mb_mgr_aes192_cbc_enc_flush_x4_sse.o \
+	mb_mgr_aes192_cbc_enc_submit_x4_sse.o \
+	mb_mgr_aes256_cbc_enc_flush_x4_sse.o \
+	mb_mgr_aes256_cbc_enc_submit_x4_sse.o \
+	mb_mgr_aes128_cbc_enc_flush_x8_sse.o \
+	mb_mgr_aes128_cbc_enc_submit_x8_sse.o \

=== perf/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2017-2021, Intel Corporation
+# Copyright (c) 2017-2022, Intel Corporation
 # 
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -28,7 +28,9 @@
 LIB_DIR ?= ../lib
 NASM ?= nasm
 
-CFLAGS = -DLINUX -D_GNU_SOURCE -DNO_COMPAT_IMB_API_053 $(INCLUDES) \
+MINGW ?= $(shell $(CC) -dM -E - < /dev/null | grep -i mingw | wc -l | sed 's/^ *//')
+
+CFLAGS = -D_GNU_SOURCE -DNO_COMPAT_IMB_API_053 $(INCLUDES) \
 	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
 	-Wcast-qual -Wundef -Wwrite-strings  \
 	-Wformat -Wformat-security \
@@ -36,19 +38,27 @@
 	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition \
 	-pthread -fno-strict-overflow -fno-delete-null-pointer-checks -fwrapv
 
+ifeq ($(MINGW),0)
+CFLAGS += -DLINUX
 NASM_FLAGS := -Werror -felf64 -Xgnu -gdwarf -DLINUX -D__linux__
+else
+NASM_FLAGS := -Werror -fwin64 -Xvc -gcv8 -DWIN_ABI
+endif
 
 # if "-z ibt" is supported then assume "-z shstk, -z cet-report=error" are also supported
 # "-fcf-protection" needs to be checked separately
+ifeq ($(MINGW),0)
 CC_HAS_CET = $(and $(shell $(CC) --target-help 2> /dev/null | grep -m1 -e "-z ibt" | wc -l), \
 	$(shell $(CC) --help=common 2> /dev/null | grep -m1 -e "-fcf-protection" | wc -l))
 CET_LDFLAGS=-r -z ibt -z shstk
-
+endif
 ifeq ($(CC_HAS_CET),1)
 CFLAGS += -fcf-protection=full
 endif
 
+ifeq ($(MINGW),0)
 LDFLAGS = -fPIE -z noexecstack -z relro -z now -pthread
+endif
 ifeq ($(CC_HAS_CET),1)
 LDFLAGS += -fcf-protection=full -Wl,-z,ibt -Wl,-z,shstk -Wl,-z,cet-report=error
 endif
@@ -68,7 +78,11 @@
 CFLAGS += -g -DDEBUG $(DEBUG_OPT)
 LDFLAGS += -g
 else
+ifeq ($(MINGW),0)
 CFLAGS += -O3 -fPIE -fstack-protector -D_FORTIFY_SOURCE=2
+else
+CFLAGS += -O2 -fPIE
+endif
 endif
 
 SOURCES := ipsec_perf.c msr.c

=== test/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2012-2021, Intel Corporation
+# Copyright (c) 2012-2022, Intel Corporation
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -27,6 +27,8 @@
 
 TEST_APP := ipsec_MB_testapp
 XVALID_APP := ipsec_xvalid_test
+FUZZ_APP := job_api_fuzz_test
+ACVP_APP := acvp_app
 INSTPATH ?= /usr/include/intel-ipsec-mb.h
 LIB_DIR ?= ../lib
 
@@ -34,7 +36,9 @@
 YASM ?= yasm
 NASM ?= nasm
 
-CFLAGS = -MMD -DLINUX -D_GNU_SOURCE -DNO_COMPAT_IMB_API_053 \
+MINGW ?= $(shell $(CC) -dM -E - < /dev/null | grep -i mingw | wc -l | sed 's/^ *//')
+
+CFLAGS = -MMD -D_GNU_SOURCE -DNO_COMPAT_IMB_API_053 \
 	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
 	-Wcast-qual -Wundef -Wwrite-strings  \
 	-Wformat -Wformat-security \
@@ -44,18 +48,30 @@
 
 # if "-z ibt" is supported then assume "-z shstk, -z cet-report=error" are also supported
 # "-fcf-protection" needs to be checked separately
+ifeq ($(MINGW),0)
 CC_HAS_CET = $(and $(shell $(CC) --target-help 2> /dev/null | grep -m1 -e "-z ibt" | wc -l), \
 	$(shell $(CC) --help=common 2> /dev/null | grep -m1 -e "-fcf-protection" | wc -l))
 CET_LDFLAGS=-r -z ibt -z shstk
+endif
 
 ifeq ($(CC_HAS_CET),1)
 CFLAGS += -fcf-protection=full
 endif
 
 YASM_FLAGS := -f x64 -f elf64 -X gnu -g dwarf2 -DLINUX -D__linux__
+ifeq ($(MINGW),0)
+CFLAGS += -DLINUX
 NASM_FLAGS := -Werror -felf64 -Xgnu -gdwarf -DLINUX -D__linux__
-
+else
+NASM_FLAGS := -Werror -fwin64 -Xvc -gcv8 -DWIN_ABI
+endif
+
+ifeq ($(MINGW),0)
 LDFLAGS = -fPIE -z noexecstack -z relro -z now
+else
+LDFLAGS = -fPIE
+endif
+
 ifeq ($(CC_HAS_CET),1)
 LDFLAGS += -fcf-protection=full -Wl,-z,ibt -Wl,-z,shstk -Wl,-z,cet-report=error
 endif
@@ -69,14 +85,27 @@
 CFLAGS +=  -I../lib/include -I../lib
 LDFLAGS += -L$(LIB_DIR)
 endif
+
+FUZZ_CFLAGS = -I../lib -L../lib $(CFLAGS) -g -fsanitize=fuzzer,address,leak
 
 DEBUG_OPT ?= -O0
 ifeq ($(DEBUG),y)
 CFLAGS += $(DEBUG_OPT) -DDEBUG -g
 LDFLAGS += -g
 else
+ifeq ($(MINGW),0)
 CFLAGS += -O3
-endif
+else
+CFLAGS += -O2
+endif
+endif
+
+ACVP_LOC ?= /usr/local/acvp
+ACVP_HDR ?= $(ACVP_LOC)/include
+ACVP_LIB ?= $(ACVP_LOC)/lib
+ACVP_CFLAGS = -I$(ACVP_HDR) $(CFLAGS)
+ACVP_LDFLAGS = -L$(ACVP_LIB) $(LDFLAGS)
+ACVP_LDLIBS = -lacvp $(LDLIBS)
 
 # ipsec_MB_testapp modules
 SOURCES := main.c gcm_test.c ctr_test.c customop_test.c des_test.c ccm_test.c \
@@ -84,14 +113,24 @@
 	hmac_md5_test.c aes_test.c sha_test.c chained_test.c api_test.c pon_test.c \
 	ecb_test.c zuc_test.c kasumi_test.c snow3g_test.c direct_api_test.c clear_mem_test.c \
 	hec_test.c xcbc_test.c aes_cbcs_test.c crc_test.c chacha_test.c poly1305_test.c \
-	chacha20_poly1305_test.c null_test.c snow_v_test.c
+	chacha20_poly1305_test.c null_test.c snow_v_test.c direct_api_param_test.c
 OBJECTS := $(SOURCES:%.c=%.o)
+
+ifneq ($(PIN_CEC_ROOT),)
+CFLAGS += -I$(PIN_CEC_ROOT)/include -DPIN_BASED_CEC
+endif
 
 # ipsec_xvalid_test modules
 XVALID_ASM := misc.asm
 XVALID_SOURCES := ipsec_xvalid.c utils.c
 XVALID_OBJECTS := $(XVALID_SOURCES:%.c=%.o) $(XVALID_ASM:%.asm=%.o)
 
+# fuzz modules
+FUZZ_SOURCES := job_api_fuzz_test.c
+
+# acvp_app modules
+ACVP_SOURCES := acvp_app_main.c utils.c
+
 # list of present dependency files
 DEP_FILES = $(wildcard ./*.d)
 
@@ -108,7 +147,7 @@
 endif
 
 # targets come here
-all: $(TEST_APP) $(XVALID_APP)
+all: $(TEST_APP) $(XVALID_APP) $(FUZZ_APP) $(ACVP_APP)
 
 $(TEST_APP): $(OBJECTS)
 	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@
@@ -116,9 +155,24 @@
 $(XVALID_APP): $(XVALID_OBJECTS)
 	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@
 
+$(ACVP_APP): $(ACVP_SOURCES)
+ifneq ("$(wildcard $(ACVP_HDR))","")
+	$(CC) $(ACVP_CFLAGS) $(ACVP_LDFLAGS) $^ $(ACVP_LDLIBS) -o $@
+else
+	@echo "No libacvp header found at $(ACVP_HDR), $(ACVP_APP) is not built"
+endif
+
+$(FUZZ_APP): $(FUZZ_SOURCES)
+ifneq (, $(shell which clang))
+	clang $(FUZZ_CFLAGS) $(FUZZ_SOURCES) $(LDLIBS) -o $@
+else
+	@echo "Clang is not installed. $(FUZZ_APP) is not built"
+endif
+
+
 .PHONY: clean
 clean:
-	-rm -f $(OBJECTS) $(TEST_APP) $(DEP_FILES) $(XVALID_OBJECTS) $(XVALID_APP) $(ASM_OBJECTS)
+	-rm -f $(OBJECTS) $(TEST_APP) $(DEP_FILES) $(XVALID_OBJECTS) $(XVALID_APP) $(ASM_OBJECTS) $(FUZZ_APP) $(ACVP_APP)
 
 # style check section
 CHECKPATCH?=checkpatch.pl

=== debian/changelog ===
intel-ipsec-mb (1.2-1) unstable; urgency=medium

  * Sync to latest 1.2 release
  * Update maintainer to colin.i.king@gmail.com

 -- Colin Ian King <colin.i.king@gmail.com>  Fri, 18 Feb 2022 11:40:11 +0000

intel-ipsec-mb (1.1-1) unstable; urgency=medium

  * Sync to latest 1.1 release
  * Update maintainer to colin.king@ubuntu.com as they no longer
    work for Canonical.

 -- Colin Ian King <colin.king@ubuntu.com>  Fri, 29 Oct 2021 11:40:11 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

DESTDIR=$$(pwd)/debian/tmp
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
HDRDIR=/usr/include
MANDIR=/usr/share/man/man7

VERSION_MAJOR=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f1)
VERSION_MINOR=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f2)
VERSION_PATCH=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f3)

MAN1 = libipsec-mb.7
MAN2 = libipsec-mb-dev.7

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); SHARED=y dh_auto_build
	find . -name "*.o" -exec rm {} \;
	$(shell dpkg-buildflags --export=sh); SHARED=n dh_auto_build

override_dh_auto_install:
	# Install the library
	find $$(pwd) -name "libIPSec_MB.so*" -exec ls -al {} \;
	install -d ${DESTDIR}${LIBDIR}
	install -m 0644 $$(pwd)/lib/libIPSec_MB.a ${DESTDIR}${LIBDIR}
	install -m 0644 $$(pwd)/lib/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH} ${DESTDIR}${LIBDIR}

	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH} ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}
	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR} ${DESTDIR}${LIBDIR}/libIPSec_MB.so

	#dpkg-shlibdeps ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR}

	# Install the header files
	install -d ${DESTDIR}${HDRDIR}
	install -m 0644 $$(pwd)/lib/intel-ipsec-mb.h ${DESTDIR}${HDRDIR}

	# Install man pages
	install -d ${DESTDIR}${MANDIR}
	install -m 0444 $$(pwd)/lib/${MAN1} ${DESTDIR}${MANDIR}
	install -m 0444 $$(pwd)/lib/${MAN2} ${DESTDIR}${MANDIR}

#
# Disable elf debug optimization step
#
override_dh_dwz:

%:
	dh $@
	dh_makeshlibs
	dh_shlibdeps
